// #autoload
// #name = DioShieldHUD
// #version = 3.5
// #date = 12/3/2001 2:47AM
// #status = release
// #author = |Rx|Diogenes
// #warrior = Diogenes
// #email = diogenes@tribalpharmacy.com
// #web = http://www.tribalpharmacy.com
// #description = Adds a blue ring to your reticle when your ShieldPack is activated, along with options to turn the sheildpack off when you jet, and a large text HUD for notification.
// #category = DioScripts
// #credit = RaptorLord for his text addition to the HUD, Halide for his lock warning which was inspiration for the ring idea.
// #config = DioShieldHUDConfig


package DioShieldHUD {
	
function DioShieldHUDOn(%this){
	reticleFrameBlueHud.setVisible(1);
	if($pref::DioShieldHUD::TextHUD){
        	ShieldOnNotifyHUD.setVisible(1);
        }
        if($pref::DioShieldHUD::KillJets){
	 	DioShieldHUDBinds.push();
	}
}

function DioShieldHUDOff(%this){
	reticleFrameBlueHud.setVisible(0);
	ShieldOnNotifyHUD.setVisible(0);
	DioShieldHUDBinds.pop();
}


function DioShieldHUD::MouseJet(%val){
	if(%val){
		usebackpack(1);
		jump(); 
		jump();
		mousejet();
	}
	else{
		mousejet();
	}
}

function DioShieldHUD::setup(%this){
	
	addMessageCallback('MsgShieldPackOn', DioShieldHUDOn);
	addMessageCallback('MsgShieldPackOff', DioShieldHUDOff);
	addMessageCallback('MsgGameOver', DioShieldHUDOff);
	callback.add(onUserClientDrop, DioShieldHUDOff);
	
	%x = (getWord($pref::Video::resolution, 0)/2)-70;
	%y = (getWord($pref::Video::resolution, 1)/2)+(getWord($pref::Video::resolution, 1)/5);
	
	new HudCrosshair(reticleFrameBlueHud) {
		profile = "GuiButtonProfile";
		horizSizing = "right";
		vertSizing = "bottom";
		position = "96 96";
		extent = "64 64";
		minExtent = "8 8";
		visible = "0";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
		fillColor = "0.250000 0.250000 0.250000 0.250000";
		frameColor = "0.000000 0.000000 1.000000 1.000000";
		opacity = "1";
		bitmap = "gui/hud_retrng_blue";
		autoCenter = "1";
		autoResize = "1";
		flipVertical = "0";
		flipHorizontal = "0";
	};

	retCenterHud.add(reticleFrameBlueHud);

	new GuiTextCtrl(ShieldOnNotifyHUD) {
		profile = "ShellBigTextProfile";
		horizSizing = "relative";
		vertSizing = "center";
		position = %x @" "@ %y;
		extent = "140 22";
		minExtent = "8 8";
		visible = "0";
		helpTag = "0";
		text = "SHIELD: ON";
		maxLength = "255";
	};

	PlayGui.add(ShieldOnNotifyHUD);
	
	new GuiControl(DioShieldHUDConfig) {
		profile = "GuiDefaultProfile";
		horizSizing = "center";
		vertSizing = "center";
		position = "0 0";
		extent = "640 480";
		minExtent = "8 8";
		visible = "1";
		hideCursor = "0";
		bypassHideCursor = "0";
		helpTag = "0";
	
		new ShellPaneCtrl() {
			profile = "ShellPaneProfile";
			horizSizing = "center";
			vertSizing = "center";
			position = "0 0";
			extent = "251 110";
			minExtent = "48 92";
			visible = "1";
			hideCursor = "0";
			bypassHideCursor = "0";
			helpTag = "0";
			text = "DioShieldHUD";
			longTextBuffer = "0";
			maxLength = "255";
			noTitleBar = "0";
	
			new ShellFieldCtrl() {
				profile = "ShellFieldProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "20 29";
				extent = "211 63";
				minExtent = "16 18";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				helpTag = "0";
			};
	
			new ShellToggleButton(DioShieldHUDTextButton) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "45 33";
				extent = "155 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::DioShieldHUD::TextHUD";
				helpTag = "0";
				text = "SHIELD:ON TEXT HUD";
				maxLength = "255";
			};
			new ShellToggleButton(DioShieldHUDJetButton) {
				profile = "ShellRadioProfile";
				horizSizing = "right";
				vertSizing = "bottom";
				position = "45 63";
				extent = "155 30";
				minExtent = "26 27";
				visible = "1";
				hideCursor = "0";
				bypassHideCursor = "0";
				variable = "$pref::DioShieldHUD::KillJets";
				helpTag = "0";
				text = "DISABLE SHIELDS ON JET";
				maxLength = "255";
			};
		};
	};
	
	if($pref::DioScavenge::Enabled $= ""){
		$pref::DioShieldHUD::Enabled = true;
		$pref::DioShieldHUD::TextHUD = true;
		$pref::DioShieldHUD::KillJets = true;
	}

	DioShieldHUDTextButton.setValue($pref::DioShieldHUD::TextHUD);	
	DioShieldHUDJetButton.setValue($pref::DioShieldHUD::KillJets);	

	if (isObject(HM) && isObject(HudMover)){
		hudmover::addhud(ShieldOnNotifyHUD, "ShieldOn");
	}
	
	if (!isObject(DioShieldHUDBinds)){
		if(movemap.getBinding(JumpAndJet) !$=  ""){
			%bind = strreplace(movemap.getBinding(JumpAndJet), "\t", " ");
		}
		else if(movemap.getBinding(mouseJet) !$=  ""){
			%bind = strreplace(movemap.getBinding(mouseJet), "\t", " ");
		}
		
		new actionMap(DioShieldHUDBinds);
		%device = getword(%bind,0);
		%key = getword(%bind,1);
		echo(%bind);
		DioShieldHUDBinds.bindCmd(%device, %key, "DioShieldHUD::MouseJet(1);", "DioShieldHUD::MouseJet(0);");
	}
		

}


};

activatePackage(DioShieldHUD);

DioShieldHUD::setup();
